
/* events handling */

var dragged_node = null;
var dropped_node = null;
var drag_x = 0;
var drag_y = 0;

function do_mouse_down(e) {
    if (!e) {
        var e = window.event;
        }
    dragged_node = (e.target) ? e.target : e.srcElement;
    if (dragged_node.getAttribute('goodie:draggable') != null) {
        dragged_node.style.position = "relative";
        drag_x = e.clientX;
        drag_y = e.clientY;
        document.onmousemove = mouse_dragging_on;
        document.onmouseup = mouse_dragging_off;
    } else {
        dragged_node = null;
    }
    return false;
}

function mouse_dragging_on(e) {
    if (!e) {
        var e = window.event;
    }
    if (dragged_node != null) {
        dragged_node.style.left = e.clientX - drag_x + 'px';
        dragged_node.style.top = e.clientY - drag_y + 'px';
    }
    return false;
}

function mouse_dragging_off(e) {
    if (!e) {
        var e = window.event;
    }
    try {
        dragged_node.style.left = '0px';
        dragged_node.style.top = '0px';
    } catch(z) { 
    }
    dropped_node = dragged_node;
    dragged_node = null;
}

function do_mouse_over(e) {
    if (!e) {
        var e = window.event;
    }
    dest_node = (e.target) ? e.target : e.srcElement
    try {
        if ( dropped_node != null && dest_node.getAttribute('goodie:dropcart') != null) {
            var id = dropped_node.getAttribute('goodie:id');
            if (id != null) {
                aServer.cart_widget(new Kw({'cart_content': cart_content, 'autosave': autosave, 'add_to_cart': id}), cart_widget_callback);
            } 
        } else if ( dropped_node != null && dest_node.getAttribute('goodie:dropbasket') != null) {
            var cartid = dropped_node.getAttribute('goodie:cartid');
            if (cartid != null) {
                aServer.cart_widget(new Kw({'cart_content': cart_content, 'autosave': autosave, 'delete_index_from_cart': cartid}), cart_widget_callback);
            }
        }
    } catch(z) { 
    }            
    dropped_node = null;
    return false;
}    

document.onmousedown = do_mouse_down;
document.onmouseover= do_mouse_over;

/* json handling */

var cart_content = [];
var jsonrpc = imprt("jsonrpc");
var Kw = imprt("pythonkw").PythonKw;
addr="."
try{var aServer = new jsonrpc.ServiceProxy(addr, ["cart_widget"]);
    }catch(e){error(e);}

function cart_widget_callback(result, err) {
    if (!err) {
        // Replace the widget returned
        var node = document.getElementById("cart_widget_wrapper");
        node.innerHTML = result;
        // Execute its script tag manually
        var script_node = document.getElementById("cart_content_json");
        eval(script_node.innerHTML);
    } else {
        // do something with err
        error(err);
    }
}


